local DBGN = DBGN
DBGN.LAM = LibAddonMenu2
DBGN.MainMenuPanel = nil

local function nvl(a, b) if a == nil then return b end return a end

function DBGN:GetActiveSectionsString(sec)
  if self.isPerfectPixel and sec == 3 or self.isShissuRoster and sec == 2 or not self.isPerfectPixel and not self.isShissuRoster and sec == 1 then
    return self.i18n.Section_Cur
  end
  return ""
end

function DBGN:CreateOptionsPanel()
  local SV = self.SV
  local SV_DC = self.SV_DC
  local Lang = self.i18n
  local DefXY = self.DefXY
  local Guild = self.GetGuildDB()
  local GuildDC = self.GetGuildDC()
  local OptPanel = {
    type = "panel",
    name = "DBGN",
    author = "|c779cff@ForgottenLight|r [EU]",
    version = DBGN.Version,
    registerForRefresh = true,
    registerForDefaults = true,
  } -- OptPanel end
--===========================================--
--== Section with static elements of panel ==--
--===========================================--
  local DBGNOptions = {
    { type = "header",
      name = ZO_HIGHLIGHT_TEXT:Colorize(Lang.OptGeneralHdr),
    },
    { type = "checkbox",
      name = Lang.SaveEnabled,
      tooltip = nvl(Lang.SaveEnabledTT,Lang.SaveEnabled),
      getFunc = function() return SV.Filters.SaveEnabled end,
      setFunc = function(Val) SV.Filters.SaveEnabled = Val end,
      default = false,
    },
    { type = "checkbox",
      name = Lang.OutUncomplTrial,
      tooltip = nvl(Lang.OutUncomplTrialTT,Lang.OutUncomplTrial),
      getFunc = function() return SV.OutUncomplTrial end,
      setFunc = function(Val) SV.OutUncomplTrial = Val end,
      default = false,
    },
    { type = "checkbox",
      name = Lang.DropNotificationsMotD,
      tooltip = nvl(Lang.DropNotificationsMotDTT,Lang.DropNotificationsMotD),
      getFunc = function() return SV.DropNotificationsMotD end,
      setFunc = function(Val) SV.DropNotificationsMotD = Val end,
      default = false,
      requiresReload = true,
    },
-- FILTER BUTTON SECTION --
    { type = "divider",
      width = "full",
    },
    { type = "description",
      text = Lang.Section_4 .. self:GetActiveSectionsString(1),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.BttN.X - DefXY.BttN.DX,
      max = DefXY.BttN.X + DefXY.BttN.DX,
      getFunc = function() return SV.BttFilters.X end,
      setFunc = function(Val) SV.BttFilters.X = Val; DBGN:MoveFilterButtons(SV.BttFilters, SV.BttFiltersSh, SV.BttFiltersPP) end,
      default = DefXY.BttN.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.BttN.Y - DefXY.BttN.DY,
      max = DefXY.BttN.Y + DefXY.BttN.DY,
      getFunc = function() return SV.BttFilters.Y end,
      setFunc = function(Val) SV.BttFilters.Y = Val; DBGN:MoveFilterButtons(SV.BttFilters, SV.BttFiltersSh, SV.BttFiltersPP) end,
      default = DefXY.BttN.Y,
    },
    { type = "description",
      text = Lang.Section_5 .. self:GetActiveSectionsString(2),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.BttS.X - DefXY.BttS.DX,
      max = DefXY.BttS.X + DefXY.BttS.DX,
      getFunc = function() return SV.BttFiltersSh.X end,
      setFunc = function(Val) SV.BttFiltersSh.X = Val; DBGN:MoveFilterButtons(SV.BttFilters, SV.BttFiltersSh, SV.BttFiltersPP) end,
      default = DefXY.BttS.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.BttS.Y - DefXY.BttS.DY,
      max = DefXY.BttS.Y + DefXY.BttS.DY,
      getFunc = function() return SV.BttFiltersSh.Y end,
      setFunc = function(Val) SV.BttFiltersSh.Y = Val; DBGN:MoveFilterButtons(SV.BttFilters, SV.BttFiltersSh, SV.BttFiltersPP) end,
      default = DefXY.BttS.Y,
    },
    { type = "description",
      text = Lang.Section_6 .. self:GetActiveSectionsString(3),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.BttP.X - DefXY.BttP.DX,
      max = DefXY.BttP.X + DefXY.BttP.DX,
      getFunc = function() return SV.BttFiltersPP.X end,
      setFunc = function(Val) SV.BttFiltersPP.X = Val; DBGN:MoveFilterButtons(SV.BttFilters, SV.BttFiltersSh, SV.BttFiltersPP) end,
      default = DefXY.BttP.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.BttP.Y - DefXY.BttP.DY,
      max = DefXY.BttP.Y + DefXY.BttP.DY,
      getFunc = function() return SV.BttFiltersPP.Y end,
      setFunc = function(Val) SV.BttFiltersPP.Y = Val; DBGN:MoveFilterButtons(SV.BttFilters, SV.BttFiltersSh, SV.BttFiltersPP) end,
      default = DefXY.BttP.Y,
    },
-- DBGN: FILTER WINDOW SECTION --
    { type = "header",
      name = ZO_HIGHLIGHT_TEXT:Colorize(Lang.OptDBGNHdr),
    },
    { type = "description",
      text = Lang.Section_1 .. self:GetActiveSectionsString(1),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.WinFN.X - DefXY.WinFN.DX,
      max = DefXY.WinFN.X + DefXY.WinFN.DX,
      getFunc = function() return SV.WinFilters.X end,
      setFunc = function(Val) SV.WinFilters.X = Val; DBGN:MoveWinFilters(Guild.UI_Fl, SV.WinFilters, SV.WinFiltersSh, SV.WinFiltersPP) end,
      default = DefXY.WinFN.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.WinFN.Y - DefXY.WinFN.DY,
      max = DefXY.WinFN.Y + DefXY.WinFN.DY,
      getFunc = function() return SV.WinFilters.Y end,
      setFunc = function(Val) SV.WinFilters.Y = Val; DBGN:MoveWinFilters(Guild.UI_Fl, SV.WinFilters, SV.WinFiltersSh, SV.WinFiltersPP) end,
      default = DefXY.WinFN.Y,
    },
    { type = "description",
      text = Lang.Section_2 .. self:GetActiveSectionsString(2),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.WinFS.X - DefXY.WinFS.DX,
      max = DefXY.WinFS.X + DefXY.WinFS.DX,
      getFunc = function() return SV.WinFiltersSh.X end,
      setFunc = function(Val) SV.WinFiltersSh.X = Val; DBGN:MoveWinFilters(Guild.UI_Fl, SV.WinFilters, SV.WinFiltersSh, SV.WinFiltersPP) end,
      default = DefXY.WinFS.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.WinFS.Y - DefXY.WinFS.DY,
      max = DefXY.WinFS.Y + DefXY.WinFS.DY,
      getFunc = function() return SV.WinFiltersSh.Y end,
      setFunc = function(Val) SV.WinFiltersSh.Y = Val; DBGN:MoveWinFilters(Guild.UI_Fl, SV.WinFilters, SV.WinFiltersSh, SV.WinFiltersPP) end,
      default = DefXY.WinFS.Y,
    },
    { type = "description",
      text = Lang.Section_3 .. self:GetActiveSectionsString(3),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.WinFP.X - DefXY.WinFP.DX,
      max = DefXY.WinFP.X + DefXY.WinFP.DX,
      getFunc = function() return SV.WinFiltersPP.X end,
      setFunc = function(Val) SV.WinFiltersPP.X = Val; DBGN:MoveWinFilters(Guild.UI_Fl, SV.WinFilters, SV.WinFiltersSh, SV.WinFiltersPP) end,
      default = DefXY.WinFP.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.WinFP.Y - DefXY.WinFP.DY,
      max = DefXY.WinFP.Y + DefXY.WinFP.DY,
      getFunc = function() return SV.WinFiltersPP.Y end,
      setFunc = function(Val) SV.WinFiltersPP.Y = Val; DBGN:MoveWinFilters(Guild.UI_Fl, SV.WinFilters, SV.WinFiltersSh, SV.WinFiltersPP) end,
      default = DefXY.WinFP.Y,
    },
-- DCGN: FILTER WINDOW SECTION --
    { type = "header",
      name = ZO_HIGHLIGHT_TEXT:Colorize(Lang.OptDCGNHdr),
    },
    { type = "description",
      text = Lang.Section_1 .. self:GetActiveSectionsString(1),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.WinFN.X - DefXY.WinFN.DX,
      max = DefXY.WinFN.X + DefXY.WinFN.DX,
      getFunc = function() return SV_DC.WinFilters.X end,
      setFunc = function(Val) SV_DC.WinFilters.X = Val; DBGN:MoveWinFilters(GuildDC.UI_Fl, SV_DC.WinFilters, SV_DC.WinFiltersSh, SV_DC.WinFiltersPP) end,
      default = DefXY.WinFN.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.WinFN.Y - DefXY.WinFN.DY,
      max = DefXY.WinFN.Y + DefXY.WinFN.DY,
      getFunc = function() return SV_DC.WinFilters.Y end,
      setFunc = function(Val) SV_DC.WinFilters.Y = Val; DBGN:MoveWinFilters(GuildDC.UI_Fl, SV_DC.WinFilters, SV_DC.WinFiltersSh, SV_DC.WinFiltersPP) end,
      default = DefXY.WinFN.Y,
    },
    { type = "description",
      text = Lang.Section_2 .. self:GetActiveSectionsString(2),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.WinFS.X - DefXY.WinFS.DX,
      max = DefXY.WinFS.X + DefXY.WinFS.DX,
      getFunc = function() return SV_DC.WinFiltersSh.X end,
      setFunc = function(Val) SV_DC.WinFiltersSh.X = Val; DBGN:MoveWinFilters(GuildDC.UI_Fl, SV_DC.WinFilters, SV_DC.WinFiltersSh, SV_DC.WinFiltersPP) end,
      default = DefXY.WinFS.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.WinFS.Y - DefXY.WinFS.DY,
      max = DefXY.WinFS.Y + DefXY.WinFS.DY,
      getFunc = function() return SV_DC.WinFiltersSh.Y end,
      setFunc = function(Val) SV_DC.WinFiltersSh.Y = Val; DBGN:MoveWinFilters(GuildDC.UI_Fl, SV_DC.WinFilters, SV_DC.WinFiltersSh, SV_DC.WinFiltersPP) end,
      default = DefXY.WinFS.Y,
    },
    { type = "description",
      text = Lang.Section_3 .. self:GetActiveSectionsString(3),
    },
    { type = "slider",
      name = Lang.Shift_X,
      tooltip = Lang.Shift_X,
      min = DefXY.WinFP.X - DefXY.WinFP.DX,
      max = DefXY.WinFP.X + DefXY.WinFP.DX,
      getFunc = function() return SV_DC.WinFiltersPP.X end,
      setFunc = function(Val) SV_DC.WinFiltersPP.X = Val; DBGN:MoveWinFilters(GuildDC.UI_Fl, SV_DC.WinFilters, SV.WinFiltersSh, SV_DC.WinFiltersPP) end,
      default = DefXY.WinFP.X,
    },
    { type = "slider",
      name = Lang.Shift_Y,
      tooltip = Lang.Shift_Y,
      min = DefXY.WinFP.Y - DefXY.WinFP.DY,
      max = DefXY.WinFP.Y + DefXY.WinFP.DY,
      getFunc = function() return SV_DC.WinFiltersPP.Y end,
      setFunc = function(Val) SV_DC.WinFiltersPP.Y = Val; DBGN:MoveWinFilters(GuildDC.UI_Fl, SV_DC.WinFilters, SV.WinFiltersSh, SV_DC.WinFiltersPP) end,
      default = DefXY.WinFP.Y,
    },
  } -- DBGNOptions end

  -- Register Option Controls
  self.MainMenuPanel = self.LAM:RegisterAddonPanel("DBGN_Panel", OptPanel)
  self.LAM:RegisterOptionControls("DBGN_Panel", DBGNOptions)
end -- -= CreateOptionsPanel end =-
